From 614bbffbb8ae922bdf19b1b628427ffe4531ec98 Mon Sep 17 00:00:00 2001
From: Roman Arzumanyan <r.arzumanyan@visionlabs.ai>
Date: Fri, 29 Sep 2023 15:36:31 +0300
Subject: [PATCH] libavutil/hwcontext_cuda: fix cuda_device_uninit when using
 current CUDA context

---
 libavutil/hwcontext_cuda.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/libavutil/hwcontext_cuda.c b/libavutil/hwcontext_cuda.c
index c648723285..0312d3b9d7 100644
--- a/libavutil/hwcontext_cuda.c
+++ b/libavutil/hwcontext_cuda.c
@@ -290,7 +290,7 @@ static void cuda_device_uninit(AVHWDeviceContext *device_ctx)
         if (hwctx->internal->is_allocated && hwctx->cuda_ctx) {
             if (hwctx->internal->flags & AV_CUDA_USE_PRIMARY_CONTEXT)
                 CHECK_CU(cu->cuDevicePrimaryCtxRelease(hwctx->internal->cuda_device));
-            else
+            else if (!(hwctx->internal->flags & AV_CUDA_USE_CURRENT_CONTEXT))
                 CHECK_CU(cu->cuCtxDestroy(hwctx->cuda_ctx));
 
             hwctx->cuda_ctx = NULL;
-- 
2.39.3 (Apple Git-145)

